'use strict';

var lezerJmespath = require('lezer-jmespath');
var language = require('@codemirror/language');

/**
A language provider that provides jmespath parsing.
*/
const jmespathLanguage = language.LRLanguage.define({
    name: "jmespath",
    parser: lezerJmespath.parser.configure({
        props: [
            language.indentNodeProp.add({
                MultiSelectHash: language.continuedIndent({ except: /^\s*\}/ }),
                MultiSelectList: language.continuedIndent({ except: /^\s*\]/ })
            }),
            language.foldNodeProp.add({
                "MultiSelectHash MultiSelectList": language.foldInside
            })
        ]
    }),
    languageData: {
        closeBrackets: { brackets: ["[", "{", '"'] },
        indentOnInput: /^\s*[\}\]]$/
    }
});
/**
jmespath language support.
*/
function jmespath() {
    return new language.LanguageSupport(jmespathLanguage);
}

exports.jmespath = jmespath;
exports.jmespathLanguage = jmespathLanguage;
